package dataStructures;

/**
 * <p>Titulo: A interface do TDA Hashable</p>
 * <p>Descrio: Necessrio a elementos usados em funes de disperso</p>
 * @version 1.0
 */

public interface HashFunction {

  /**
   * Calcula o valor de disperso de uma dada chave
   * @param key A chave a ser calculada
   * @return O valor dessa chave
   */
  //@ requires isHashable(key);
  int hashValue(Object key);

  /**
   * Verifica se um dado objecto tem valor de disperso
   * @param key A chave a verificar
   * @return TRUE se tem valor de disperso, FALSE c.c.
   */
  /*@ pure @*/ boolean isHashable(Object key);

  /**
   * Calcula o n-simo valor depois de (n-1) colises, em relaao
   *  ltima chave inquirida.
   * @return O prximo valor
   */
  int nextValue();

} // endInterface HashFunction